=== requirements.txt ===
click
mmcif-pdbx
numpy
pybind11
pyparsing
python-dev-tools
