=== src/fem/CMakeLists.txt ===
add_items(
    SOURCES
    vcsm.c
    vfetk.c
    vpee.c
)

add_items(
    EXTERNAL_HEADERS
    vcsm.h
    vfetk.h
    vpee.h
)

add_sublibrary(fem apbs_generic)
