=== src/geoflow/CMakeLists.txt ===
add_items(
    SOURCES
    geoflow_wrap_apbs.cpp
)

add_items(
    EXTERNAL_HEADERS
    geoflow_wrap_apbs.h
)

add_sublibrary(geoflow_apbs)
