=== debian/changelog ===
apbs (3.4.1-7) unstable; urgency=medium

  * Team upload.
  [ Adrian Bunk ]
  * Build with -std=gnu17 to workaround FTBFS with GCC 15.
    Closes: #1096316.

 -- Santiago Vila <sanvila@debian.org>  Sun, 21 Sep 2025 17:25:00 +0200

apbs (3.4.1-6) unstable; urgency=medium

  * Team upload.

  [ Drew Parsons ]
  * fix build with gcc-14. Closes: #1077646.
    - patch vf2c in debian/external_deps/fetk
    - debian patch gcc14.patch reverts an upstream hack in vfetk
      function definitions that prevent building with gcc-14.
  * add hashbang to debian/tests/test-apbs. Thanks Simon Chopin.
    Closes: #1033528.
  * Build-Depends: pkgconf not pkg-config
  * mark apbs-doc Multi-Arch: foreign
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Thu, 31 Oct 2024 14:24:17 +0100

apbs (3.4.1-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061891

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 01:04:53 +0000

apbs (3.4.1-5) unstable; urgency=medium

  * Team upload.
  * Add patch to drop obsolete "U" mode passed to open(), which causes runtime
    errors with python 3.11, by Steve Langasek. Closes: #1028354.

 -- Michael Banck <mbanck@debian.org>  Tue, 10 Jan 2023 21:56:38 +0100

apbs (3.4.1-4) unstable; urgency=medium

  * Team upload.
  * update patch on FETK punc component vf2c/uninit.c to test for
    availability of _FPU_MASK_IM rather than __mips to allow riscv64
    to build.
  * patch FETK punc component vf2c/uninit.c to define Masks for
    riscv64 interrupts. Thanks Bo YU. Closes: #1012302.
  * Standards-Version: 4.6.1

 -- Drew Parsons <dparsons@debian.org>  Sat, 04 Jun 2022 09:58:09 +0200

apbs (3.4.1-3) unstable; urgency=medium

  * Team upload.
  * patch FETK punc component vf2c/uninit.c to use specific MIPS fpu
    masks with _FPU_SETCW. Closes: #1012177.

 -- Drew Parsons <dparsons@debian.org>  Wed, 01 Jun 2022 13:43:34 +0200

apbs (3.4.1-2) unstable; urgency=medium

  * Team upload.
  * Build-Depends-Indep: python3-yaml (to build docs)
  * add specific copyright entries for FETK components
    punc/src/pmg (GPL) and punc/src/vf2c (AT&T)
  * patch FETK punc component vf2c/uninit.c to not run __mips block on
    linux
  * don't double-up bin dir in path for apbs tools. Closes: #979339.
  * debian/rules: run build-time tests after dh_auto_install
  * FETK is now provided (built against system SuperLU), and debci
    tests pass. Closes: #1006382, #1008726.

 -- Drew Parsons <dparsons@debian.org>  Tue, 31 May 2022 02:52:47 +0200

apbs (3.4.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - requires FETK
    - Build-Depends: pybuild-plugin-pyproject, python3-pybind11
    - drop deprecated debian patches debian_make.patch and
      link_libapbs_routines.patch
  * provide FETK external source as a git subtree in
    debian/external_deps/fetk. Source is pulled from
    https://github.com/Electrostatics/FETK, the required
    version is specified in the toplevel apbs CMakeLists.txt
    - pull FETK 1.9.3 (commit 57195e5) to use system SuperLU
    - patch to use system maloc (don't build local maloc)
    - patch mc and punc with BLA_STATIC OFF to used BLAS shared
      libraries, and don't specify BLA_VENDOR OpenBLAS (use generic
      blas to allow for alternative optimised BLASes)
    - build FETK libraries (libmc.so, libgamer.so, libpunc.so,
      also punc components libcgcode.so, libvf2c.so)
      with soname set by FETK project minor version (currently 1.9)
    - provide FETK libraries in libfetk-dev and libfetk1.9 packages.
    - FETK copyright licence is LGPL-2.1+
    - Build-Depends: libsuitesparse-dev (for libumfpack),
      libarpack2-dev
  * python3-apbslib provides both apbs and apbslib python modules
  * update debian/rules
    - specify cmake build with source at top level
    - specify APBS_STATIC_BUILD=Off
  * update debian patch python3.patch to fix check of PYTHON_MAX_VERSION
    and only copy python library files to a pdb2pka dir it exists
  * add debian patch cmake.patch
    - adjusts upstream cmake files to install headers in
      /usr/include/apbs, and don't install (unformed) docs
    - add RPC_CFLAGS (/usr/include/tirpc) to CFLAGS in
      ImportFETK.cmake to include FETK RPC support.
      Build-Depends: libtirpc-dev (using pkg-config)
    - treat PYTHON_VERSION (3.6) as minimum not exact version
    - skip RPATH in shared library build (CMAKE_SKIP_RPATH=ON)
  * provide apbs-doc package
    - build user docs with sphinxdoc, libjs-mathjax
    - Build-Depends-Indep: python3-sphinx-rtd-theme
  * fix ©,Å symbols with UTF-8 via debian patch
    fix_spelling_errors.patch and direct in FETK
  * add apbs_check_intermediate_energies.py to
    debian patch wrong-path-for-interpreter.patch and replace with
    "env python3" as needed (following upstream more closely)
  * update upstream source to https://github.com/Electrostatics/apbs
  * upstream source no longer includes pdb2pqr, don't need to
    exclude it and repackage the source (drop +dfsg1)
  * Standards-Version: 4.6.0
  * lintian updates

 -- Drew Parsons <dparsons@debian.org>  Sun, 29 May 2022 10:42:09 +0200
