=== debian/control ===
Source: apbs
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Section: science
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), cmake,
 debhelper-compat (= 13),
 dh-python,
 pybuild-plugin-pyproject,
 pkgconf,
 libarpack2-dev,
 libmaloc-dev,
 libsuitesparse-dev,
 libsuperlu-dev,
 libtirpc-dev,
 mpi-default-dev,
 python3,
 python3-dev,
 python3-pybind11,
 python3-setuptools,
 python3-sphinx | sphinx,
 swig,
 zlib1g-dev
Build-Depends-Indep: libjs-mathjax,
 python3-sphinx-rtd-theme,
 python3-yaml
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debichem-team/apbs
Vcs-Git: https://salsa.debian.org/debichem-team/apbs.git
Homepage: http://www.poissonboltzmann.org/

Package: apbs
Architecture: any
Depends: apbs-data (= ${source:Version}),
 libapbs3t64 (= ${binary:Version}),
 libjs-mathjax,
 ${misc:Depends},
 ${shlibs:Depends},
 ${sphinxdoc:Depends}
Description: Adaptive Poisson Boltzmann Solver
 APBS is a software package for the numerical solution of the
 Poisson-Boltzmann equation (PBE), one of the most popular continuum
 models for describing electrostatic interactions between molecular
 solutes in salty, aqueous media.  Continuum electrostatics plays an
 important role in several areas of biomolecular simulation, including:
 .
   * simulation of diffusional processes to determine ligand-protein and
     protein-protein binding kinetics,
   * implicit solvent molecular dynamics of biomolecules ,
   * solvation and binding energy calculations to determine
     ligand-protein and protein-protein equilibrium binding constants
     and aid in rational drug design,
   * and biomolecular titration studies.
 .
 APBS was designed to efficiently evaluate electrostatic properties for
 such simulations for a wide range of length scales to enable the
 investigation of molecules with tens to millions of atoms.
 .
 This package contains the apbs program and utilities.

Package: python3-apbslib
Section: python
Architecture: any
Depends: libapbs3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Adaptive Poisson Boltzmann Solver
 APBS is a software package for the numerical solution of the
 Poisson-Boltzmann equation (PBE), one of the most popular continuum
 models for describing electrostatic interactions between molecular
 solutes in salty, aqueous media.
 .
 This package provides both the apbs and apbslib modules for Python3
 enabling Python applications to access apbs.

Package: libapbs-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libapbs3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Adaptive Poisson Boltzmann Solver
 APBS is a software package for the numerical solution of the
 Poisson-Boltzmann equation (PBE), one of the most popular continuum
 models for describing electrostatic interactions between molecular
 solutes in salty, aqueous media.
 .
 This package contains the development headers to build against
 libapbs_* shared libraries.

Package: libapbs3t64
Provides: ${t64:Provides}
Replaces: libapbs3
Breaks: libapbs3 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Adaptive Poisson Boltzmann Solver
 APBS is a software package for the numerical solution of the
 Poisson-Boltzmann equation (PBE), one of the most popular continuum
 models for describing electrostatic interactions between molecular
 solutes in salty, aqueous media.
 .
 This package contains the libapbs_* shared libraries.

Package: apbs-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: apbs (<= 1.4-2)
Description: data files for APBS (Adaptive Poisson Boltzmann Solver)
 APBS is a software package for the numerical solution of the
 Poisson-Boltzmann equation (PBE), one of the most popular continuum
 models for describing electrostatic interactions between molecular
 solutes in salty, aqueous media.
 .
 This package contains all data files for apbs package to reduce the 
 redundancy between architectures in Debian.

Package: apbs-doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-mathjax,
 ${misc:Depends},
 ${sphinxdoc:Depends}
Recommends: apbs
Suggests: python3-apbslib
Description: Adaptive Poisson Boltzmann Solver
 APBS is a software package for the numerical solution of the
 Poisson-Boltzmann equation (PBE), one of the most popular continuum
 models for describing electrostatic interactions between molecular
 solutes in salty, aqueous media.  Continuum electrostatics plays an
 important role in several areas of biomolecular simulation, including:
 .
   * simulation of diffusional processes to determine ligand-protein and
     protein-protein binding kinetics,
   * implicit solvent molecular dynamics of biomolecules ,
   * solvation and binding energy calculations to determine
     ligand-protein and protein-protein equilibrium binding constants
     and aid in rational drug design,
   * and biomolecular titration studies.
 .
 APBS was designed to efficiently evaluate electrostatic properties for
 such simulations for a wide range of length scales to enable the
 investigation of molecules with tens to millions of atoms.
 .
 This package contains the apbs documentation.

Package: libfetk-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libfetk1.9t64 (= ${binary:Version}),
 libmaloc-dev,
 ${misc:Depends},
 ${shlibs:Depends},
Description: FETK libraries for APBS (development headers)
 The Finite Element ToolKit (FETK) is a collection of adaptive finite
 element method (AFEM) software libraries and tools for solving
 coupled systems of nonlinear geometric partial differential equations
 (PDE). The FETK libraries and tools are written in an object-oriented
 form of ANSI-C and in C++, and include a collection of standard
 numerical libraries (PUNC), a stand-alone high-quality surface and
 volume simplex mesh generator (GAMer), a stand-alone networked
 polygon display tool (SG), a general nonlinear finite element
 modeling kernel (MC)
 .
 This package provides a fork of FETK intended for use by APBS
 (Adaptive Poisson Boltzmann Solver).
 .
 The FETK component MALOC (Minimal Abstraction Layer for
 Object-oriented C/C++ programs) is provided separately by
 libmaloc-dev.
 .
 This package contains the development headers to build against
 libapbs_* shared libraries.

Package: libfetk1.9t64
Provides: ${t64:Provides}
Replaces: libfetk1.9
Breaks: libfetk1.9 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: FETK libraries for APBS (shared libraries)
 The Finite Element ToolKit (FETK) is a collection of adaptive finite
 element method (AFEM) software libraries and tools for solving
 coupled systems of nonlinear geometric partial differential equations
 (PDE). The FETK libraries and tools are written in an object-oriented
 form of ANSI-C and in C++, and include a collection of standard
 numerical libraries (PUNC), a stand-alone high-quality surface and
 volume simplex mesh generator (GAMer), a stand-alone networked
 polygon display tool (SG), a general nonlinear finite element
 modeling kernel (MC)
 .
 This package provides a fork of FETK intended for use by APBS
 (Adaptive Poisson Boltzmann Solver).
 .
 The FETK component MALOC (Minimal Abstraction Layer for
 Object-oriented C/C++ programs) is provided separately via
 libmaloc-dev.
 .
 This package contains the libgamer, libmc, libpunc (and libcgcode,
 libvf2c) shared libraries.
