=== debian/tests/control ===
Tests: test-apbs
Depends: @, python3
Restrictions: allow-stderr
